"use strict";
// Copyright (c) Jupyter Development Team.
// Distributed under the terms of the Modified BSD License.
Object.defineProperty(exports, "__esModule", { value: true });
const base_1 = require("@jupyter-widgets/base");
const widget_1 = require("./widget");
const version_1 = require("./version");
const EXTENSION_ID = 'clustergrammer_widget2';
/**
 * The example plugin.
 */
const examplePlugin = {
    id: EXTENSION_ID,
    requires: [base_1.IJupyterWidgetRegistry],
    activate: activateWidgetExtension,
    autoStart: true
};
exports.default = examplePlugin;
/**
 * Activate the widget extension.
 */
function activateWidgetExtension(app, registry) {
    registry.registerWidget({
        name: 'clustergrammer_widget2',
        version: version_1.EXTENSION_SPEC_VERSION,
        exports: {
            ExampleModel: widget_1.ExampleModel,
            ExampleView: widget_1.ExampleView
        }
    });
}
